<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_category_edit.php                                  ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/tree.php");

	check_admin_security("products_categories");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_category_edit.html");

	$t->set_var("admin_upload_href", "admin_upload.php");
	$t->set_var("admin_category_edit_href", "admin_category_edit.php");
	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");

	$category_id = get_param("category_id");

	$r = new VA_Record($table_prefix . "categories");
	
	$r->add_where("category_id", INTEGER);
	$r->add_checkbox("is_showing", INTEGER, "Show on Site");
	$r->add_textbox("category_name", TEXT, "Category Name");
	$r->change_property("category_name", REQUIRED, true);
	$r->add_textbox("category_order", TEXT, "Category Order");
	$r->change_property("category_order", REQUIRED, true);
	$r->add_textbox("short_description", TEXT);
	$r->add_textbox("full_description", TEXT);
	$r->add_textbox("image", TEXT);
	$r->add_textbox("parent_category_id", TEXT);
	$r->change_property("parent_category_id", USE_IN_UPDATE, false);
	$r->add_textbox("category_path", TEXT);
	$r->change_property("category_path", USE_IN_UPDATE, false);

	$r->get_form_values();

	if(!strlen($r->get_value("parent_category_id"))) $r->set_value("parent_category_id", "0");
	$parent_category_id = $r->get_value("parent_category_id");

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
	$tree->show($parent_category_id);

	$operation = get_param("operation");
	$return_page = "admin_items_list.php?category_id=" . $parent_category_id;
	if(strlen($operation))
	{
		$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "");

		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $r->get_value("category_id"))
		{
			$categories = "";
			$category_path = $tree->get_path($category_id);
			$sql  = " SELECT category_id FROM " . $table_prefix . "categories ";
			$sql .= " WHERE category_id=" . $db->tosql($category_id, INTEGER);
			$sql .= " OR category_path LIKE '" . $db->tosql($category_path, TEXT, false) . "%'";
			$db->query($sql);
			while($db->next_record())
				$categories[] = $db->f("category_id");

			if(is_array($categories))
			{
				for($i = 0; $i < sizeof($categories); $i++)
				{
					$db->query("DELETE FROM " . $table_prefix . "categories WHERE category_id=" . $db->tosql($categories[$i], INTEGER));
					$db->query("DELETE FROM " . $table_prefix . "items_categories WHERE category_id=" . $db->tosql($categories[$i], INTEGER));
				}
			}
	
			header("Location: " . $return_page);
			exit;
		}

		$is_valid = $r->validate();
		
		if($is_valid)
		{
			if(strlen($r->get_value("category_id")))
			{
				$r->update_record();
			}
			else
			{
				$r->set_value("category_path", $tree->get_path($r->get_value("parent_category_id")));
				$r->insert_record();
			}
			header("Location: " . $return_page);
			exit;
		}
	} else if(strlen($r->get_value("category_id")))	{
		$r->get_db_values();
	} else {
		$category_order = get_db_value("SELECT MAX(category_order) FROM " . $table_prefix . "categories WHERE parent_category_id=" . $db->tosql($parent_category_id, INTEGER));
		$category_order++;
		$r->set_value("category_order", $category_order);
	}

	$r->set_parameters();

	if(strlen($category_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>