<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_forum_thread.php                                   ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/navigator.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/date_functions.php");

	check_admin_security("forum");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_forum_thread.html");

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_forum_href", "admin_forum.php");
	$t->set_var("admin_forum_thread_href", "admin_forum_thread.php");
	$t->set_var("admin_forum_message_href", "admin_forum_message.php");
	$t->set_var("admin_forum_topic_href", "admin_forum_topic.php");

	$t->set_var("rnd", time());

	$thread_id = get_param("thread_id");
	$operation = get_param("operation");
	$rnd = get_param("rnd");

	$errors = "";

	if(!strlen($thread_id)) {
		$errors = "Missing '<b>Thread ID</b>' parameter.";
	}

	$return_page = "admin_forum_thread.php?thread_id=" . $thread_id;

	$sql  = " SELECT user_name, user_email, remote_address, topic, ";
	$sql .= " description, email_notification, date_added, date_modified, views, replies ";
	$sql .= " FROM " . $table_prefix . "forum ";
	$sql .= " WHERE thread_id=" . $db->tosql($thread_id, INTEGER);

	$db->query($sql);
	if($db->next_record() && !strlen($errors))
	{
		$topic_user_name = $db->f("user_name");
		$topic_user_email = $db->f("user_email");
		$topic_remote_address = $db->f("remote_address");
		$t->set_var("topic_added_by", $topic_user_name);
		$t->set_var("topic_user_name", $topic_user_name);
		$t->set_var("topic_nickname", $topic_user_name);
		$t->set_var("topic_user_email", $topic_user_email);
		$t->set_var("topic_remote_address", $topic_remote_address);
		$t->set_var("topic_user_ip", $topic_remote_address);

		$date_modified = $db->f("date_modified", DATETIME);
		$date_modified_string = va_date($datetime_show_format, $date_modified);
		$t->set_var("date_modified", $date_modified_string);
		$t->set_var("topic_modified", $date_modified_string);
		$t->set_var("topic_date_modified", $date_modified_string);

		$date_added = $db->f("date_added", DATETIME);
		$date_added_string = va_date($datetime_show_format, $date_added);
		$t->set_var("topic_added", $date_added_string);
		$t->set_var("topic_date_added", $date_added_string);

		$t->set_var("topic", htmlspecialchars($db->f("topic")));
		$description = htmlspecialchars($db->f("description"));
		$t->set_var("topic_description", nl2br($description));

		$email_notification = $db->f("email_notification");

		$views = intval($db->f("views"));
		$replies = intval($db->f("replies"));
		$t->set_var("views", $views);
		$t->set_var("replies", $replies);

		$last_message = $description;

		$sql  = " UPDATE " . $table_prefix . "forum SET views=" . $db->tosql(($views + 1), INTEGER);
		$sql .= " WHERE thread_id=" . $db->tosql($thread_id, INTEGER);
		//don't count admins views
		//$db->query($sql);
	}
	else if(!strlen($errors))
	{
		$errors = "'<b>Thread ID</b>' parameter has wrong value.";
	}

	if(strlen($errors))
	{
		$t->set_var("errors_list", $errors);
		$t->parse("global_errors", false);
		$t->pparse("main", false);
		return;
	}


	$r = new VA_Record($table_prefix . "forum_messages");

	$r->add_textbox("thread_id", INTEGER);
	$r->add_textbox("admin_id", INTEGER);
	$r->add_textbox("user_name", TEXT, "Nickname");
	$r->parameters["user_name"][REQUIRED] = true;
	$r->add_textbox("user_email", TEXT, "Email");
	$r->parameters["user_email"][REQUIRED] = true;
	$r->add_textbox("remote_address", TEXT);
	$r->add_textbox("message_text", TEXT, "Message");
	$r->parameters["message_text"][REQUIRED] = true;

	$r->add_textbox("date_added", DATETIME);

	$r->get_form_values();


	$session_rnd = get_session("session_rnd");
	$operation = get_param("operation");
	$rnd = get_param("rnd");

	if($operation && $rnd != $session_rnd)
	{

		$sql  = " SELECT admin_name, email FROM " . $table_prefix . "admins ";
		$sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
		$db->query($sql);
		if($db->next_record())
		{
			$r->set_value("user_name", $db->f("admin_name"));
			$r->set_value("user_email", $db->f("email"));
		}

		$is_valid = $r->validate();

		if($is_valid)
		{
			$date_added = va_time();
			$remote_address = getenv("REMOTE_ADDR");
			$r->set_value("date_added", $date_added);
			$r->set_value("remote_address", $remote_address);
			$r->set_value("admin_id", get_session("session_admin_id"));

			if($r->insert_record())
			{ 
				setcookie("cookie_forum_nick", $r->get_value("user_name"), time() + 3600 * 24 * 366);  
				setcookie("cookie_forum_email", $r->get_value("user_email"), time() + 3600 * 24 * 366);  

				$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='forum'";
				$db->query($sql);
				while($db->next_record())
					$forum_settings[$db->f("setting_name")] = $db->f("setting_value");

				if($email_notification || (isset($forum_settings["admin_notification"]) && $forum_settings["admin_notification"]))
				{
					// prepare variables
					$date_added_string = va_date($datetime_show_format, $date_added);
			  
					// set variables for email
					$r->set_parameters();
					$t->set_var("date_added", $date_added_string);
					$t->set_var("message_added", $date_added_string);
					$t->set_var("message_date_added", $date_added_string);
					$t->set_var("date_modified", $date_added_string);
					$t->set_var("topic_modified", $date_added_string);
					$t->set_var("topic_date_modified", $date_added_string);

					$t->set_var("added_by", $r->get_value("user_name"));
					$t->set_var("nickname", $r->get_value("user_name"));
					$t->set_var("message_added_by", $r->get_value("user_name"));
					$t->set_var("message_user_name", $r->get_value("user_name"));
					$t->set_var("message_nickname", $r->get_value("user_name"));

					$t->set_var("user_email", $r->get_value("user_email"));
					$t->set_var("message_user_email", $r->get_value("user_email"));

					$t->set_var("message_remote_address", $r->get_value("remote_address"));
					$t->set_var("message_user_ip", $r->get_value("remote_address"));

					$t->set_var("message", $r->get_value("message_text"));

					$t->set_var("topic_description", $description);
					$t->set_var("description", $description);
					$t->set_var("topic_message", $description);

					// send notification to site administrator
					if(isset($forum_settings["admin_notification"]) && $forum_settings["admin_notification"])
					{			  
						$t->set_block("admin_subject", $forum_settings["admin_subject"]);
						$t->set_block("admin_message", $forum_settings["admin_message"]);
						$t->parse("admin_subject", false);
						$t->parse("admin_message", false);

						$mail_to = get_setting_value($forum_settings, "admin_email", $settings["admin_email"]);
						$mail_from = get_setting_value($forum_settings, "admin_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($forum_settings, "cc_emails");
						$mail_bcc = get_setting_value($forum_settings, "admin_mail_bcc");
						$mail_reply_to = get_setting_value($forum_settings, "admin_mail_reply_to");
						$mail_return_path = get_setting_value($forum_settings, "admin_mail_return_path");
						$mail_type = get_setting_value($forum_settings, "admin_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

						$admin_message = str_replace("\r", "", $t->get_var("admin_message"));
						mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
					}
					// send notification to topic owner
					if($email_notification)
					{			  
						$t->set_block("user_subject", $forum_settings["user_subject"]);
						$t->set_block("user_message", $forum_settings["user_message"]);
						$t->parse("user_subject", false);
						$t->parse("user_message", false);

						$mail_from = get_setting_value($forum_settings, "user_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($forum_settings, "user_mail_cc");
						$mail_bcc = get_setting_value($forum_settings, "user_mail_bcc");
						$mail_reply_to = get_setting_value($forum_settings, "user_mail_reply_to");
						$mail_return_path = get_setting_value($forum_settings, "user_mail_return_path");
						$mail_type = get_setting_value($forum_settings, "user_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

						$user_message = str_replace("\r", "", $t->get_var("user_message"));
						mail($topic_user_email, $t->get_var("user_subject"), $user_message, $email_headers);
					}

				}

        // update forum topic info
				$sql  = " UPDATE " . $table_prefix . "forum SET replies=" . $db->tosql(($replies + 1), INTEGER);
				$sql .= " , date_modified=" . $db->tosql($date_added, DATETIME);
				$sql .= " WHERE thread_id=" . $db->tosql($thread_id, INTEGER);
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}
		else
		{
			//$r->errors .= "Please provide information in the sections with red, italicized headings, then click 'Submit'.<br>";	
			set_session("session_rnd", "");
		}
	}
	else // new page (set default values)
	{
		$r->set_value("user_name", get_cookie("cookie_forum_nick"));
		$r->set_value("user_email", get_cookie("cookie_forum_email"));
	}

	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_forum_thread.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "forum WHERE thread_id=" . $db->tosql($thread_id, INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT message_id,admin_id,user_name,user_email,remote_address, ";
	$sql .= " message_text, date_added ";
	$sql .= " FROM " . $table_prefix . "forum_messages  ";
	$sql .= " WHERE thread_id=" . $db->tosql($thread_id, INTEGER);
	$sql .= " ORDER BY date_added DESC ";

	$db->query($sql);
	if($db->next_record())
	{
		$t->set_var("thread_id", $thread_id);
		$last_message = $db->f("message_text");
		do
		{
			$t->set_var("message_user_name", $db->f("user_name"));
			$t->set_var("message_user_email", $db->f("user_email"));
			$t->set_var("message_user_ip", $db->f("remote_address"));
			$t->set_var("message_id", $db->f("message_id"));

			if(strlen($db->f("admin_id")))
			{
				$t->parse("admin_block", false);
				$t->set_var("user_block", "");
			}
			else 
			{
				$t->parse("user_block", false);
				$t->set_var("admin_block", "");
			}

			$date_added = $db->f("date_added", DATETIME);
			$date_added_string = va_date($datetime_show_format, $date_added);
			$t->set_var("date_added", $date_added_string);

			$t->set_var("message_text", nl2br(htmlspecialchars($db->f("message_text"))));

			$t->parse("records", true);
		} while($db->next_record());

	}
	else
	{
		$t->set_var("records", "");
	}


	if(!strlen($operation)) // (set default message text for reply)
	{
		$last_message = ">" . str_replace("\n", "\n>", $last_message);
		$r->set_value("message_text", $last_message);
	}

	$r->set_parameters();
	$t->set_var("page", $page_number);
	$t->set_var("rp", urlencode($return_page));

	$t->pparse("main");

?>