<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_shipping_type.php                                  ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("static_tables");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_shipping_type.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_lookup_tables_href", "admin_lookup_tables.php");
	$t->set_var("admin_shipping_types_href", "admin_shipping_types.php");
	$t->set_var("admin_shipping_type_href", "admin_shipping_type.php");
	$t->set_var("weight_measure", $settings["weight_measure"]);

	$r = new VA_Record($table_prefix . "shipping_types");
	$r->return_page = "admin_shipping_types.php";

	$r->add_where("shipping_type_id", INTEGER);
	$r->add_textbox("shipping_type_desc", TEXT, "Shipping Type Description");
	$r->change_property("shipping_type_desc", REQUIRED, true);
	$r->add_textbox("min_goods_cost", NUMBER, "Minimum Goods Cost");
	$r->change_property("min_goods_cost", REQUIRED, true);
	$r->add_textbox("max_goods_cost", NUMBER, "Maximum Goods Cost");
	$r->change_property("max_goods_cost", REQUIRED, true);
	$r->add_textbox("min_weight", NUMBER, "Minimum Weight");
	$r->change_property("min_weight", REQUIRED, true);
	$r->add_textbox("max_weight", NUMBER, "Maximum Weight");
	$r->change_property("max_weight", REQUIRED, true);
	$r->add_textbox("cost_per_order", NUMBER);
	$r->add_textbox("cost_per_product", NUMBER);
	$r->add_textbox("cost_per_weight", NUMBER);
	$r->events[BEFORE_INSERT] = "set_shipping_type_id";
	$r->events[AFTER_INSERT] = "update_shipping_countries";
	$r->events[AFTER_UPDATE] = "update_shipping_countries";
	$r->events[AFTER_DELETE] = "delete_shipping_countries";

	$r->process();

	$t->set_var("countries", "");
	$t->set_var("selected_countries", "");

	$sql = " SELECT country_code, country_name FROM " . $table_prefix . "countries ORDER BY country_order, country_name ";
	$db->query($sql);
	while($db->next_record())
	{
		$t->set_var("country_code", strtoupper($db->f("country_code")));
		$t->set_var("country_name", str_replace("\"", "&qout;", $db->f("country_name")));
		$t->parse("countries");
	}

	$operation = get_param("operation");
	if ($operation == "save") {
		$countries = get_param("countries");
		if($countries) {
			$selected_countries = split(",", $countries);
			for($i = 0; $i < sizeof($selected_countries); $i++) {
				$t->set_var("country_code", strtoupper($selected_countries[$i]));
				$t->parse("selected_countries");
			}
		}
	} else if($r->get_value("shipping_type_id")) {
		$sql = " SELECT country_code FROM " . $table_prefix . "shipping_types_countries WHERE shipping_type_id=" . $db->tosql($r->get_value("shipping_type_id"), INTEGER);
		$db->query($sql);
		while($db->next_record())
		{
			$t->set_var("country_code", strtoupper($db->f("country_code")));
			$t->parse("selected_countries");
		}
	}

	include("./admin_header.php");
	include("./admin_footer.php");


	$t->pparse("main");

	function set_shipping_type_id()  {
		global $db, $table_prefix, $r;
		$sql = "SELECT MAX(shipping_type_id) FROM " . $table_prefix . "shipping_types";
		$db->query($sql);
		if($db->next_record()) {
			$shipping_type_id = $db->f(0) + 1;
			$r->change_property("shipping_type_id", USE_IN_INSERT, true);
			$r->set_value("shipping_type_id", $shipping_type_id);
		}	
	}

	function update_shipping_countries()  {
		global $db, $table_prefix, $r;

		$shipping_type_id = $r->get_value("shipping_type_id");
		$countries = get_param("countries");
		$selected_countries = split(",", $countries);
		
		$db->query("DELETE FROM " . $table_prefix . "shipping_types_countries WHERE shipping_type_id=" . $db->tosql($shipping_type_id, INTEGER));
		for($i = 0; $i < sizeof($selected_countries); $i++) {
			$db->query("INSERT INTO " . $table_prefix . "shipping_types_countries (shipping_type_id, country_code) VALUES (" . $db->tosql($shipping_type_id, INTEGER) . "," . $db->tosql($selected_countries[$i], TEXT) . ")");
		}
	}

	function delete_shipping_countries()  {
		global $db, $table_prefix, $r;
		$shipping_type_id = $r->get_value("shipping_type_id");
		$db->query("DELETE FROM " . $table_prefix . "shipping_types_countries WHERE shipping_type_id=" . $db->tosql($shipping_type_id, INTEGER));
	}

?>