<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_tax_rate.php                                       ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("static_tables");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_tax_rate.html");

	$t->set_var("admin_tax_rate_href", "admin_tax_rate.php");
	$t->set_var("admin_tax_rates_href", "admin_tax_rates.php");

	$r = new VA_Record($table_prefix . "tax_rates");

	// load data to listbox
	$countries = get_db_values("SELECT country_code,country_name FROM " . $table_prefix . "countries ORDER BY country_order, country_name ", array(array("", "--- Select Country ---")));

	$r->add_where("tax_id", INTEGER);

	$r->add_textbox("tax_name", TEXT, "Tax Name");
	$r->change_property("tax_name", REQUIRED, true);
	$r->add_select("country_code", TEXT, $countries, "Country");
	$r->change_property("country_code", REQUIRED, true);

	$r->add_textbox("tax_percent", FLOAT, "Tax Percent");
	$r->change_property("tax_percent", REQUIRED, true);

	$r->get_form_values();

	$operation = get_param("operation");
	$tax_id = get_param("tax_id");
	$return_page = "admin_tax_rates.php";

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $tax_id)
		{
			$r->delete_record();
			header("Location: " . $return_page);
			exit;
		}

		$r->validate();

		if(!$r->is_empty("country_code")) {
			$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "tax_rates ";
			$sql .= " WHERE country_code=" . $db->tosql($r->get_value("country_code"), TEXT);
			$sql .= $r->is_empty("tax_id") ? "" : " AND tax_id<>" . $db->tosql($tax_id, INTEGER);
			if(get_db_value($sql)) {
				$r->errors .= "Tax for country <b>" . get_array_value($r->get_value("country_code"), $countries) . "</b> already exists.";
			}
		}


		if(!strlen($r->errors))
		{
			if(strlen($r->get_value("tax_id")))
				$r->update_record();
			else
				$r->insert_record();

			header("Location: " . $return_page);
			exit;
		}
	}
	else if(strlen($r->get_value("tax_id")))
	{
		$r->get_db_values();
	}
	else // new item (set default values)
	{
	}


	$r->set_form_parameters();
	
	if(strlen($tax_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_lookup_tables_href", "admin_lookup_tables.php");
	$t->set_var("admin_tax_rates_href", "admin_tax_rates.php");
	$t->pparse("main");

?>
