<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  articles_category_edit.php                               ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/tree.php");

	check_admin_security("articles_categories");

  	$t = new VA_Template($settings["admin_templates_dir"]);
  	$t->set_file("main","articles_category_edit.html");

	$t->set_var("articles_upload_href", "articles_upload.php");
	$t->set_var("articles_category_edit_href", "articles_category_edit.php");
	$t->set_var("articles_select_href", "articles_select.php");
	$t->set_var("articles_list_href", "articles_list.php");

	$category_id = get_param("category_id");

	$r = new VA_Record($table_prefix . "articles_categories");
	
	$r->add_where("category_id", INTEGER);
	$r->add_textbox("category_name", TEXT, "Category name");
	$r->change_property("category_name", REQUIRED, true);
	$r->change_property("category_name", MAX_LENGTH, 255);
	$r->add_textbox("category_order", TEXT, "Category order");
	$r->change_property("category_order", REQUIRED, true);
	$r->add_textbox("language_code", TEXT, "Language code");
	$r->change_property("language_code", MAX_LENGTH, 2);
	$r->add_textbox("category_list_template", TEXT, "Category list template");
	$r->change_property("category_list_template", MAX_LENGTH, 255);
	$r->add_textbox("category_details_template", TEXT, "Category details template");
	$r->change_property("category_details_template", MAX_LENGTH, 255);
	$r->add_textbox("default_view", TEXT, "Default view");
	$r->change_property("default_view", MAX_LENGTH, 255);
	$r->add_textbox("moderators_ids", TEXT, "Moderators");
	$r->change_property("moderators_ids", MAX_LENGTH, 255);
	$r->add_checkbox("is_hot", INTEGER, "Show on main page");
	$r->add_checkbox("is_list", INTEGER, "List articles with descriptions");
	$r->add_checkbox("is_contents", INTEGER, "Show category contents");
	$values_list = array(array("0", "Nobody"), array("1", "All"), array("2", "Registered"));
	$r->add_select("allowed_view", INTEGER, $values_list, "Allow view articles");
	$r->add_checkbox("allowed_post", INTEGER, "Allow post articles");
	$r->add_checkbox("allowed_ratings", INTEGER, "Allow rate articles");
	$r->add_textbox("short_description", TEXT);
	$r->add_textbox("full_description", TEXT);
	$r->add_textbox("image_small", TEXT);
	$r->change_property("image_small", MAX_LENGTH, 255);
	$r->add_textbox("image_large", TEXT);
	$r->change_property("image_large", MAX_LENGTH, 255);
	$r->add_textbox("parent_category_id", TEXT);
	$r->change_property("parent_category_id", USE_IN_UPDATE, false);
	$r->add_textbox("alias_category_id", TEXT);
	$r->change_property("alias_category_id", USE_IN_UPDATE, false);
	$r->add_textbox("category_path", TEXT);
	$r->change_property("category_path", USE_IN_UPDATE, false);
	$r->add_textbox("total_articles", INTEGER, "Total articles");
	$r->add_textbox("total_subcategories", INTEGER, "Total subcategories");

	$r->get_form_values();

	if(!strlen($r->get_value("parent_category_id"))) $r->set_value("parent_category_id", "0");
	$parent_category_id = $r->get_value("parent_category_id");

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "tree");
	$tree->show($parent_category_id);

	$operation = get_param("operation");
	$return_page = "articles_list.php?category_id=" . $parent_category_id;
	if(strlen($operation))
	{
		$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "");

		if($operation == "cancel") {
			header("Location: " . $return_page);
			exit;
		} //cancel
		else if($operation == "delete" && $r->get_value("category_id")) {
			$categories = "";
			$category_path = $tree->get_path($category_id);
			$sql  = " SELECT category_id FROM " . $table_prefix . "articles_categories ";
			$sql .= " WHERE category_id = " . $db->tosql($category_id, INTEGER);
			$sql .= " OR category_path LIKE '" . $db->tosql($category_path, TEXT, false) . "%'";
			$db->query($sql);
			while($db->next_record())
				$categories[] = $db->f("category_id");

			if(is_array($categories)) {
				for($i = 0; $i < sizeof($categories); $i++) {
					$db->query("DELETE FROM " . $table_prefix . "articles_assigned WHERE category_id = " . $db->tosql($categories[$i], INTEGER));
					$db->query("DELETE FROM " . $table_prefix . "articles_categories WHERE category_id=" . $db->tosql($categories[$i], INTEGER));
				}
			}
			if ($parent_category_id) {
				$db->query("UPDATE " . $table_prefix . "articles_categories SET total_subcategories = total_subcategories - 1 WHERE category_id = " . $db->tosql($parent_category_id, INTEGER));
			}
	
			header("Location: " . $return_page);
			exit;
		} //delete

		$is_valid = $r->validate();
		
		if($is_valid)
		{
			if(strlen($r->get_value("category_id"))) {
				$r->update_record();
			}
			else {
				$r->set_value("category_path", $tree->get_path($r->get_value("parent_category_id")));
				$r->set_value("total_articles", 0);
				$r->set_value("total_subcategories", 0);
				$r->insert_record();
				if ($parent_category_id) {
					$db->query("UPDATE " . $table_prefix . "articles_categories SET total_subcategories = total_subcategories + 1 WHERE category_id = " . $db->tosql($parent_category_id, INTEGER));
				}
			}
			header("Location: " . $return_page);
			exit;
		}
	} 
	//no operation
	else if(strlen($r->get_value("category_id"))) {
		$r->get_db_values();
	} 
	//new category
	else {
		$category_order = get_db_value("SELECT MAX(category_order) FROM " . $table_prefix . "articles_categories WHERE parent_category_id=" . $db->tosql($parent_category_id, INTEGER));
		$category_order++;
		$r->set_value("category_order", $category_order);
	}

	$r->set_parameters();

	if(strlen($category_id)) {
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else {
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>