<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  order_items.php                                          ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	function show_order_items($order_id, $parse_template = true, $user_order = false)
	{
	 	global $t, $db, $table_prefix;
		global $settings;
		global $items_text, $cart_items, $total_items;

		$dbd = new VA_SQL();
		$dbd->DBDatabase = $db->DBDatabase;
		$dbd->DBUser     = $db->DBUser;
		$dbd->DBPassword = $db->DBPassword;
		$dbd->DBHost     = $db->DBHost;

		$currency_left = ""; $currency_right = "";
		if($settings["currency_position"] == 1)
			$currency_left = $settings["currency_sign"];
		else if($settings["currency_position"] == 2)
			$currency_right = $settings["currency_sign"];

		$goods_total = 0; $total_quantity = 0; $total_items = 0;
		$sql  = " SELECT order_item_id,item_id,item_type_id,item_name,item_properties,price,quantity ";
		$sql .= " FROM " . $table_prefix . "orders_items WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		while($db->next_record())
		{
			$total_items++;
			$order_item_id = $db->f("order_item_id");
			$item_id = $db->f("item_id");

			if($user_order) {
				$sql  = " SELECT id.download_id,i.item_name,id.download_added, ";
				$sql .= " i.download_path AS product_path, id.download_path, ";
				$sql .= " id.download_expiry ";
				$sql .= " FROM " . $table_prefix . "items_downloads id, " . $table_prefix . "items i ";
				$sql .= " WHERE id.item_id=i.item_id ";
				$sql .= " AND id.order_item_id=" . $db->tosql($order_item_id, INTEGER);
				$sql .= " AND id.order_id=" . $db->tosql($order_id, INTEGER);
				$sql .= " AND id.activated=1";
				$t->set_var("download_links", "");
				$dbd->query($sql);
				while($dbd->next_record()) {
					$download_id = $dbd->f("download_id");
					$product_path = trim($dbd->f("product_path"));
					$download_path = trim($dbd->f("download_path"));
					if(!$download_path) {
						$download_path = $product_path;
					}
					$download_added = $dbd->f("download_added", DATETIME);
					$download_expiry = $dbd->f("download_expiry", DATETIME);
					$expiry_date = mktime (0,0,0, $download_expiry[MONTH], $download_expiry[DAY], $download_expiry[YEAR]);
					$current_date = mktime(0,0,0, date("m"), date("d"), date("Y"));
					$item_download_url  = $settings["site_url"] . "download.php?download_id=" . $download_id;
					$vc = md5($download_id . $download_added[3].$download_added[4].$download_added[5]);
					$item_download_url .= "&vc=" . urlencode($vc);
					if($expiry_date > $current_date) {
						$product_paths = split(";", $download_path);
						for($di = 0; $di < sizeof($product_paths); $di++) {
							$sub_path = $product_paths[$di];
							if($sub_path) {
								$sub_url = $item_download_url . "&path_id=" . ($di + 1);
								$t->set_var("filename", basename($sub_path));
								$t->set_var("download_id", $download_id);
								$t->set_var("vc", $vc);
								$t->set_var("download_url", $sub_url);
								$t->parse("download_links");
							}
						}
					}
				}
				$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "releases  ";
				$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);;
				$dbd->query($sql);
				$dbd->next_record();
				$releases_number = $dbd->f(0);
				if($releases_number > 0) {
					$t->set_var("order_item_id", $order_item_id);
					$t->parse("releases_link", false);
				} else {
					$t->set_var("releases_link", "");
				}
			}

			$item_name = $db->f("item_name");
			$item_properties = $db->f("item_properties");
			$price = $db->f("price");
			$quantity = $db->f("quantity");
			$weight = $db->f("weight");
			$buying_price = $db->f("buying_price");
			$downloadable = $db->f("downloadable");
			$item_type_id = $db->f("item_type_id");
			$stock_level = "";
			$short_description = "";
			$full_description = "";

			$item_total = $price * $quantity;
			$goods_total += $item_total;
			$total_quantity += $quantity;

			$item_text = $item_name;
			if(strlen($item_properties))
			{
				$item_properties_text = substr($item_properties, 4, strlen($item_properties) - 4);
				$item_properties_text = str_replace("<br>", "; ", $item_properties_text);
				$item_text .= " (" . $item_properties_text . ")";
			}
			$item_text .= " Qty: " . $quantity . " " . $currency_left . number_format($item_total, 2) . $currency_right;
			$items_text .= $item_text . "\n";

			// get additional fields
			$sql  = " SELECT short_description, full_description FROM " . $table_prefix . "items ";
			$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
			$dbd->query($sql);
			if($dbd->next_record()) {
				$stock_level = $dbd->f("stock_level");
				$short_description = strip_tags($dbd->f("short_description"));
				$full_description = strip_tags($dbd->f("full_description"));
			} 

			$cart_items[] = array(
				"item_id" => $item_id, "id" => $item_id, "product_id" => $item_id, 
				"weight" => $weight, "price" => $price, "quantity" => $quantity,
				"buying_price" => $buying_price, "item_name" => $item_name, "product_name" => $item_name, 
				"product_title" => $item_name, "item_title" => $item_name, "item_total" => $item_total,
				"downloadable" => $downloadable, "item_type_id" => $item_type_id, "stock_level" => $stock_level,
				"short_description" => $short_description, "description" => $short_description, 
				"full_description" => $full_description
			);

			if($parse_template) { // set item variables into html
				$t->set_var("item_name", $item_name);
				$t->set_var("item_properties", $item_properties);
				$t->set_var("quantity", $quantity);				
				$t->set_var("price", $currency_left . number_format($price, 2) . $currency_right);
				$t->set_var("item_total", $currency_left . number_format($item_total, 2) . $currency_right);

				$t->parse("items", true);
			}
		}

		$items_text .= "Goods Total: " . $currency_left . number_format($goods_total, 2) . $currency_right . "\n";
		$sql  = " SELECT shipping_type_desc,shipping_cost,tax_name,tax_percent ";
		$sql .= " FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		$db->next_record();
		
		$shipping_type_desc = $db->f("shipping_type_desc");
		$shipping_cost = $db->f("shipping_cost");

		if($shipping_cost > 0) {
			$items_text .= $shipping_type_desc . ": " . $currency_left . number_format($shipping_cost, 2) . $currency_right . "\n";
		}
		$order_total = round($goods_total, 2) + round($shipping_cost, 2);

		$tax_name = $db->f("tax_name");
		$tax_percent = $db->f("tax_percent");

		if($tax_percent > 0) {
			$tax_cost = ($order_total * $tax_percent) / 100;
			$tax_cost = round($tax_cost, 2);
			$order_total += $tax_cost;
			$items_text .= $tax_name . ": " . $currency_left . number_format($tax_cost, 2) . $currency_right . "\n";
		}
		
		$items_text .= "Order Total: " . $currency_left . number_format($order_total, 2) . $currency_right;

		if($parse_template) {
			$t->set_var("total_quantity", $total_quantity);
			$t->set_var("goods_total", $currency_left . number_format($goods_total, 2) . $currency_right);
			if($shipping_cost > 0) {
				$t->set_var("shipping_type_desc", $shipping_type_desc);
				$t->set_var("shipping_cost", $currency_left . number_format($shipping_cost, 2) . $currency_right);
				$t->set_var("shipping_cost_desc", $currency_left . number_format($shipping_cost, 2) . $currency_right);
				$t->parse("shipping_type", false);
			}
			if($tax_percent > 0) {
				$t->set_var("tax_name", $tax_name);
				$t->set_var("tax_cost", $currency_left . number_format($tax_cost, 2) . $currency_right);
				$t->parse("tax");
			}
			$t->set_var("order_total", $currency_left . number_format($order_total, 2) . $currency_right);
		
			$t->parse("basket", false);
		}

		return $items_text;
	}

	function check_order($check_status = true)
	{
		global $db, $table_prefix;
		$errors = "";
		$order_id = get_param("order_id");
		$vc = get_param("vc");
		$sql  = " SELECT order_placed_date,order_status FROM " . $table_prefix . "orders ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if($db->next_record())
		{
			$order_placed_date = $db->f("order_placed_date", DATETIME);
			if($vc != md5($order_id . $order_placed_date[3].$order_placed_date[4].$order_placed_date[5])) {
				$errors .= ORDER_CODE_ERROR . "<br>";
			}
			if($check_status && $db->f("order_status", INTEGER) > 2) {
				$errors .= ORDER_PLACED_ERROR . "<br>";
			}
		} else {
			$errors .= ORDER_EXISTS_ERROR . "<br>";
		}

		return $errors;
	}

	function check_payment($order_id, $order_total)
	{
		global $db, $table_prefix;
		$errors = "";
		$sql  = " SELECT order_placed_date,order_total,order_status FROM " . $table_prefix . "orders ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if($db->next_record())
		{
			$order_total_db = $db->f("order_total");
			if($order_total_db != $order_total) {
				$errors .= "<b>Transaction Amount</b> and <b>Order Amount</b> doesn't match.";
			}
		} else {
			$errors .= "Such <b>Order</b> doesn't exists.<br>";
		}

		return $errors;
	}

?>