<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  user_profile.php                                         ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./includes/common.php");
	include("./includes/record.php");
	include("./includes/date_functions.php");
	include("./includes/parameters.php");

  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main","user_profile.html");

	$t->set_var("site_url", $settings["site_url"]);
	$t->set_var("user_profile_href", "user_profile.php");
	$t->set_var("user_home_href", "user_home.php");

	$t->set_var("PROFILE_TITLE",     PROFILE_TITLE);
	$t->set_var("EDIT_PROFILE_MSG",  EDIT_PROFILE_MSG);
	$t->set_var("MY_ACCOUNT_MSG",    MY_ACCOUNT_MSG);
	$t->set_var("LOGIN_INFO_MSG",    LOGIN_INFO_MSG);
	$t->set_var("PERSONAL_DETAILS_MSG", PERSONAL_DETAILS_MSG);
	$t->set_var("DELIVERY_DETAILS_MSG", DELIVERY_DETAILS_MSG);
	$t->set_var("SAME_DETAILS_MSG",   SAME_DETAILS_MSG);
	$t->set_var("REGISTER_BUTTON",    REGISTER_BUTTON);
	$t->set_var("UPDATE_BUTTON",      UPDATE_BUTTON);
	$t->set_var("CANCEL_BUTTON",      CANCEL_BUTTON);
	$t->set_var("LOGIN_FIELD",        LOGIN_FIELD);
	$t->set_var("PASSWORD_FIELD",     PASSWORD_FIELD);
	$t->set_var("CONFIRM_PASS_FIELD", CONFIRM_PASS_FIELD);
	$t->set_var("NAME_FIELD",         NAME_FIELD);
	$t->set_var("FIRST_NAME_FIELD",   FIRST_NAME_FIELD);
	$t->set_var("LAST_NAME_FIELD",    LAST_NAME_FIELD);
	$t->set_var("COMPANY_NAME_FIELD", COMPANY_NAME_FIELD);
	$t->set_var("EMAIL_FIELD",        EMAIL_FIELD);
	$t->set_var("STREET_FIRST_FIELD", STREET_FIRST_FIELD);
	$t->set_var("STREET_SECOND_FIELD",STREET_SECOND_FIELD);
	$t->set_var("CITY_FIELD",         CITY_FIELD);
	$t->set_var("PROVINCE_FIELD",     PROVINCE_FIELD);
	$t->set_var("STATE_FIELD",        STATE_FIELD);
	$t->set_var("ZIP_FIELD",          ZIP_FIELD);
	$t->set_var("COUNTRY_FIELD",      COUNTRY_FIELD);
	$t->set_var("PHONE_FIELD",        PHONE_FIELD);
	$t->set_var("DAYTIME_PHONE_FIELD",DAYTIME_PHONE_FIELD);
	$t->set_var("EVENING_PHONE_FIELD",EVENING_PHONE_FIELD);
	$t->set_var("CELL_PHONE_FIELD",   CELL_PHONE_FIELD);
	$t->set_var("FAX_FIELD",          FAX_FIELD);


	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='user_profile'";
	$db->query($sql);
	while($db->next_record()) {
		$user_profile[$db->f("setting_name")] = $db->f("setting_value");
	}

	$user_id = get_session("session_user_id");
	$r = new VA_Record($table_prefix . "users");

	$r->add_where("user_id", INTEGER);
	$r->change_property("user_id", USE_IN_INSERT, true);

	if(!$user_id)
	{
		$r->add_textbox("login", TEXT, LOGIN_FIELD);
		$r->parameters["login"][REQUIRED] = true;
		$r->parameters["login"][UNIQUE] = true;
		$r->parameters["login"][MIN_LENGTH] = 5;
		$r->add_textbox("password", TEXT, PASSWORD_FIELD);
		$r->parameters["password"][REQUIRED] = true;
		$r->parameters["password"][MIN_LENGTH] = 5;
		$r->add_textbox("confirm", TEXT, CONFIRM_PASS_FIELD);
		$r->change_property("confirm", USE_IN_SELECT, false);
		$r->change_property("confirm", USE_IN_INSERT, false);
		$r->change_property("confirm", USE_IN_UPDATE, false);
		$r->change_property("password", MATCHED, "confirm");

		$r->add_textbox("security_question", TEXT, "Security Question");
		$r->change_property("security_question", USE_SQL_NULL, false);

		$r->add_textbox("security_answer", TEXT, "Security Answer");
		$r->change_property("security_answer", USE_SQL_NULL, false);
	}

	$states = get_db_values("SELECT state_code,state_name FROM " . $table_prefix . "states", array(array("", "Non US")));
	$countries = get_db_values("SELECT country_code,country_name FROM " . $table_prefix . "countries ORDER BY country_order ", array(array("", "Select Country")));

	$r->add_textbox("name", TEXT, NAME_FIELD);
	$r->change_property("name", USE_SQL_NULL, false);
	$r->add_textbox("first_name", TEXT, FIRST_NAME_FIELD);
	$r->change_property("first_name", USE_SQL_NULL, false);
	$r->add_textbox("last_name", TEXT, LAST_NAME_FIELD);
	$r->change_property("last_name", USE_SQL_NULL, false);
	$r->add_textbox("company_name", TEXT, COMPANY_NAME_FIELD);
	$r->add_textbox("email", TEXT, EMAIL_FIELD);
	$r->change_property("email", USE_SQL_NULL, false);
	$r->change_property("email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("address1", TEXT, STREET_FIRST_FIELD);
	$r->add_textbox("address2", TEXT, STREET_SECOND_FIELD);
	$r->add_textbox("city", TEXT, CITY_FIELD);
	$r->add_textbox("province", TEXT, PROVINCE_FIELD);
	$r->add_select("state_code", TEXT, $states, STATE_FIELD);
	$r->add_textbox("zip", TEXT, ZIP_FIELD);
	$r->add_select("country_code", TEXT, $countries, COUNTRY_FIELD);
	$r->add_textbox("phone", TEXT, PHONE_FIELD);
	$r->add_textbox("daytime_phone", TEXT, DAYTIME_PHONE_FIELD);
	$r->add_textbox("evening_phone", TEXT, EVENING_PHONE_FIELD);
	$r->add_textbox("cell_phone", TEXT, CELL_PHONE_FIELD);
	$r->add_textbox("fax", TEXT, FAX_FIELD);

	$r->add_textbox("delivery_name", TEXT, DELIVERY_MSG . NAME_FIELD);
	$r->add_textbox("delivery_first_name", TEXT, DELIVERY_MSG . FIRST_NAME_FIELD);
	$r->add_textbox("delivery_last_name", TEXT, DELIVERY_MSG . LAST_NAME_FIELD);
	$r->add_textbox("delivery_company_name", TEXT, DELIVERY_MSG . COMPANY_NAME_FIELD);
	$r->add_textbox("delivery_email", TEXT, DELIVERY_MSG . EMAIL_FIELD);
	$r->change_property("delivery_email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("delivery_address1", TEXT, DELIVERY_MSG . STREET_FIRST_FIELD);
	$r->add_textbox("delivery_address2", TEXT, DELIVERY_MSG . STREET_SECOND_FIELD);
	$r->add_textbox("delivery_city", TEXT, DELIVERY_MSG . CITY_FIELD);
	$r->add_textbox("delivery_province", TEXT, DELIVERY_MSG . PROVINCE_FIELD);
	$r->add_select("delivery_state_code", TEXT, $states, DELIVERY_MSG . STATE_FIELD);
	$r->add_textbox("delivery_zip", TEXT, DELIVERY_MSG . ZIP_FIELD);
	$r->add_select("delivery_country_code", TEXT, $countries, DELIVERY_MSG . COUNTRY_FIELD);
	$r->add_textbox("delivery_phone", TEXT, DELIVERY_MSG . PHONE_FIELD);
	$r->add_textbox("delivery_daytime_phone", TEXT, DELIVERY_MSG . DAYTIME_PHONE_FIELD);
	$r->add_textbox("delivery_evening_phone", TEXT, DELIVERY_MSG . EVENING_PHONE_FIELD);
	$r->add_textbox("delivery_cell_phone", TEXT, DELIVERY_MSG . CELL_PHONE_FIELD);
	$r->add_textbox("delivery_fax", TEXT, DELIVERY_MSG . FAX_FIELD);

	$personal_number = 0;
	$delivery_number = 0;
	for($i = 0; $i < sizeof($parameters); $i++)
	{                                    
		if($user_profile["show_" . $parameters[$i]] == 1) {
			$personal_number++;
			if($user_profile[$parameters[$i] . "_required"] == 1) {
				$r->parameters[$parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters[$parameters[$i]][SHOW] = false;
		}
		if($user_profile["show_delivery_" . $parameters[$i]] == 1) {
			$delivery_number++;
			if($user_profile["delivery_" . $parameters[$i] . "_required"] == 1) {
				$r->parameters["delivery_" . $parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters["delivery_" . $parameters[$i]][SHOW] = false;
		}
	}

	$r->add_textbox("registration_date", DATETIME);
	$r->change_property("registration_date", USE_IN_SELECT, false);
	$r->add_textbox("modified_date", DATETIME);
	$r->change_property("modified_date", USE_IN_SELECT, false);

	$r->add_checkbox("same_as_personal", INTEGER);
	$r->change_property("same_as_personal", USE_IN_SELECT, false);
	$r->change_property("same_as_personal", USE_IN_INSERT, false);
	$r->change_property("same_as_personal", USE_IN_UPDATE, false);
	if($personal_number < 1 || $delivery_number < 1) {
		$r->parameters["same_as_personal"][SHOW] = false;
	}

	$r->get_form_values();

	$action = get_param("action");

	$return_page = get_param("return_page");
	if(!strlen($return_page)) $return_page = "user_home.php";
	
	if(strlen($action))
	{
		if($action == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($action == "delete" && $user_id)
		{
			// delete action disabled for users
			// $r->delete_record();
			header("Location: " . $return_page);
			exit;
		}

		if($r->get_value("same_as_personal")) {
			for($i = 0; $i < sizeof($parameters); $i++) { 
				if($user_profile["show_delivery_" . $parameters[$i]] == 1 && $user_profile["show_" . $parameters[$i]] == 1) {
					$r->set_value("delivery_" . $parameters[$i], $r->get_value($parameters[$i]));
				}
			}
		}

		$r->validate();


		if(!strlen($r->errors))
		{
			if(strlen($user_id))
			{
				$r->set_value("user_id", $user_id);
				$r->set_value("modified_date", va_time());
				$r->update_record();
			}
			else
			{
				$db->query("SELECT MAX(user_id) FROM " . $table_prefix . "users");
				$db->next_record();
				$user_id = $db->f(0) + 1;
				$r->set_value("user_id", $user_id);
				$registration_date = va_time();
				$r->set_value("registration_date", $registration_date);
				$r->set_value("modified_date", $registration_date);
				if($r->insert_record())
				{
					$registration_date_string = va_date($datetime_show_format, $registration_date);

					set_session("session_user_id", $user_id);
					set_session("session_user_login", $r->get_value("login"));
					if(!($r->is_empty("name"))) {
						$user_name = $r->get_value("name");
					} else if (!($r->is_empty("first_name")) || !($r->is_empty("last_name"))) {
						$user_name = $r->get_value("first_name") . " " . $r->get_value("last_name");
					} else {
						$user_name = $r->get_value("login");
					}
					set_session("session_user_name", $user_name);
					$user_email = $r->is_empty("email") ? "" : $r->get_value("email");
					set_session("session_user_email", $user_email);
					

					$registration_admin_email = $user_profile["admin_email"] ? $user_profile["admin_email"] : $settings["admin_email"];
					if($user_profile["admin_notification"])
					{
						$t->set_block("admin_subject", $user_profile["admin_subject"]);
						$t->set_block("admin_message", $user_profile["admin_message"]);
						$r->set_parameters();
						$t->set_var("registration_date", $registration_date_string);

						$t->parse("admin_subject", false);
						$t->parse("admin_message", false);

						$mail_to = get_setting_value($user_profile, "admin_email", $settings["admin_email"]);
						$mail_from = get_setting_value($user_profile, "admin_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($user_profile, "cc_emails");
						$mail_bcc = get_setting_value($user_profile, "admin_mail_bcc");
						$mail_reply_to = get_setting_value($user_profile, "admin_mail_reply_to");
						$mail_return_path = get_setting_value($user_profile, "admin_mail_return_path");
						$mail_type = get_setting_value($user_profile, "admin_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

						$admin_message = str_replace("\r", "", $t->get_var("admin_message"));
						mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
					}		 
					if($user_profile["user_notification"])
					{
						$t->set_block("user_subject", $user_profile["user_subject"]);
						$t->set_block("user_message", $user_profile["user_message"]);
						$r->set_parameters();
						$t->set_var("registration_date", $registration_date_string);
						$t->parse("user_subject", false);
						$t->parse("user_message", false);
						$mail_from = get_setting_value($user_profile, "user_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($user_profile, "user_mail_cc");
						$mail_bcc = get_setting_value($user_profile, "user_mail_bcc");
						$mail_reply_to = get_setting_value($user_profile, "user_mail_reply_to");
						$mail_return_path = get_setting_value($user_profile, "user_mail_return_path");
						$mail_type = get_setting_value($user_profile, "user_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

						$user_message = str_replace("\r", "", $t->get_var("user_message"));
						mail($r->get_value("email"), $t->get_var("user_subject"), $user_message, $email_headers);
					}		 
				}
			}
			header("Location: " . $return_page);
			exit;
		}
	}
	else if(strlen($user_id))
	{
		$r->set_value("user_id", $user_id);
		$r->get_db_values();
	}
	else // new record (set default values)
	{
	}

	$t->set_var("return_page", htmlspecialchars($return_page));
	$r->set_parameters();

	if(!$user_id)
		$t->parse("login_block", false);
	else
		$t->set_var("login_block", "");
	

	if($personal_number > 0)
		$t->parse("personal", false);
	else
		$t->set_var("personal", "");

	if($delivery_number > 0)
		$t->parse("delivery", false);
	else
		$t->set_var("delivery", "");

	$t->set_var("update_button", "");
	$t->set_var("register_button", "");
	if(strlen($user_id)) {
		$t->set_var("save_button_title", UPDATE_BUTTON);
		$t->global_parse("update_button", false, false, true);
	} else {
		$t->set_var("save_button_title", REGISTER_BUTTON);
		$t->global_parse("register_button", false, false, true);
	}

	if(strlen($user_id) && strlen(trim(get_setting_value($user_profile, "intro_text_registered"))))
	{
		$t->set_var("intro_text", $user_profile["intro_text_registered"]);
		$t->parse("intro_block", false);
	} else if (!strlen($user_id) && strlen(trim(get_setting_value($user_profile, "intro_text_new")))) {
		$t->set_var("intro_text", $user_profile["intro_text_new"]);
		$t->parse("intro_block", false);
	}

	if(strlen(get_session("session_user_id"))) {
		$t->parse("user_links", false);
	}

	include("./header.php");
	include("./footer.php");

	$t->pparse("main");

?>